using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.Graphics;
using Android.Graphics.Drawables;
using Java.IO;

namespace Graphics
{
    [Activity(Label = "Take Pictures Activity")]
    public class takepictures : Activity
    {
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);
            // Create your application here
            SetContentView(Resource.Layout.takepictures);
            Button btnCTP = FindViewById<Button>(Resource.Id.btnCloseTakePics);
            btnCTP.Click += new EventHandler(btnCTP_Click_Close);
            Button btnTakePicNow = FindViewById<Button>(Resource.Id.btnTakePicNow);
            btnTakePicNow.Click += new EventHandler(btnTakePicNow_Click);
        }

        void btnTakePicNow_Click(object sender, EventArgs e)
        {
            saveFullImage();
        }

        void btnCTP_Click_Close(object sender, EventArgs e)
        {
            this.Finish();
        }

        private static int TAKE_PICTURE = 1;
        //private Android.Net.Uri outputFileUri;
        //private void getThumbailPicture() {
        //    Intent intent = new Intent(Android.Provider.MediaStore.ActionImageCapture);
        //    StartActivityForResult(intent, TAKE_PICTURE);
        //}
        private void saveFullImage() {
            
            Intent intent = new Intent(Android.Provider.MediaStore.ActionImageCapture);
            Java.IO.File f = new Java.IO.File(Android.OS.Environment.ExternalStorageDirectory, 
                "appname_tmp_pic.jpg");
            var mCameraUri = Android.Net.Uri.FromFile(f);
            intent.PutExtra(Android.Provider.MediaStore.ExtraOutput, mCameraUri);
            StartActivityForResult(intent, TAKE_PICTURE);
        }

        protected override void OnActivityResult(int requestCode, Result resultCode, Intent data)
        {
            base.OnActivityResult(requestCode, resultCode, data);
            if (resultCode != Result.Ok)
            {
                return;
            }
            if (requestCode == TAKE_PICTURE)
            {
                Java.IO.File f = new Java.IO.File(Android.OS.Environment.ExternalStorageDirectory, "appname_tmp_pic.jpg");
                String uri = Android.Provider.MediaStore.Images.Media.InsertImage(ContentResolver, f.AbsolutePath, null, null);

                Android.Net.Uri dataUri = Android.Net.Uri.Parse(uri);
                var imageView = FindViewById<ImageView>(Resource.Id.takepic);
                imageView.SetImageURI(dataUri);
                GalleryAddPic(dataUri);
            }
        }

        private void GalleryAddPic(Android.Net.Uri dataUri)
        {
            Intent mediaScanIntent = new Intent(Intent.ActionMediaScannerScanFile);
            mediaScanIntent.SetData(dataUri);
            this.SendBroadcast(mediaScanIntent);
        }
    }
}