﻿using System;
using System.Threading;
using Android.App;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;

namespace LoadImages
{
    [Activity(Label = "Load Images", MainLauncher = true, Icon = "@drawable/icon")]
    public class Activity1 : Activity
    {
        int count = 1;
        private ImageView iv;
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.main);

            // Get our button from the layout resource,
            // and attach an event to it
            Button btnLoadLocal = FindViewById<Button>(Resource.Id.LoadLocal);
            Button btnLoadRemote = FindViewById<Button>(Resource.Id.LoadRemote);
            iv = FindViewById<ImageView>(Resource.Id.Image);
            btnLoadLocal.Click += delegate
            {
                iv.SetImageResource(Resource.Drawable.AndroidImageLocal);
            };

            btnLoadRemote.Click += delegate
            {
                string urlToLoad = "http://morewally.com/RemoteImage.jpg";
                System.Threading.ThreadPool.QueueUserWorkItem(
                    new WaitCallback(LoadRemoteImageViaThread), urlToLoad);
            };
        }

        private void LoadRemoteImageViaThread(object o)
        {
            string url = (string) o;
            var imageUrl = new Java.Net.URL(url);
            var bitmap = Android.Graphics.BitmapFactory.DecodeStream(imageUrl.OpenStream());
            RunOnUiThread(() => iv.SetImageBitmap(bitmap));
        }
    }
}

